<template>
  <ion-page>
    <main-top-bar />
    <div class="h-full w-full">
      <div class="p-5 flex text-lg flex-row items-center">
        <ion-text color="primary" class="flex-auto flex-col font-bold">
          {{ t("goals_page.my_goals", {}, { locale: $store.state.appLang }) }}
        </ion-text>
        <ion-icon
          v-if="goals.length"
          color="primary"
          class="w-8 h-8"
          :icon="addCircle"
          @click="openCreationGoalTitlePage()"
        />
      </div>
      <ion-content :scrollY="goalsFetched && goals.length">
        <ion-refresher slot="fixed" @ionRefresh="refreshData($event)">
          <ion-refresher-content />
        </ion-refresher>
        <div class="px-5" v-if="goalsFetched">
          <div v-if="goals.length">
            <ion-list class="pt-0 pb-0" lines="none">
              <ion-item
                class="goal-item pb-5"
                v-for="goal in goals"
                :key="goal"
              >
                <goal-item :goal="goal" />
              </ion-item>
            </ion-list>
            <ion-infinite-scroll
              @ionInfinite="loadData($event)"
              id="infinite-scroll"
            >
              <ion-infinite-scroll-content />
            </ion-infinite-scroll>
          </div>
          <div v-else class="p-5 pb-20 empty-content">
            <div class="flex flex-row justify-center">
              <ion-button
                class="w-full"
                color="primary"
                @click="openCreationGoalTitlePage()"
              >
                {{
                  t(
                    "goals_page.create_first_goal",
                    {},
                    { locale: $store.state.appLang }
                  )
                }}
              </ion-button>
            </div>
          </div>
        </div>
      </ion-content>
    </div>
  </ion-page>
</template>

<script>
import { defineComponent, ref } from "vue";
import {
  IonPage,
  IonContent,
  IonRefresher,
  IonRefresherContent,
  IonItem,
  IonList,
  IonIcon,
  IonButton,
  IonText,
  IonInfiniteScrollContent,
  IonInfiniteScroll,
} from "@ionic/vue";
import GoalItem from "../../components/GoalItem";
import MainTopBar from "../../components/MainTopBar.vue";
import { addCircle } from "ionicons/icons";
import { useI18n } from "vue-i18n";
import goalsService from "../../services/goals";
import toastService from "../../services/toast";

export default defineComponent({
  name: "Goals",
  components: {
    IonPage,
    IonContent,
    IonText,
    MainTopBar,
    IonRefresherContent,
    IonRefresher,
    IonItem,
    IonButton,
    IonList,
    IonIcon,
    IonInfiniteScrollContent,
    IonInfiniteScroll,
    GoalItem,
  },
  setup() {
    const { t, locale } = useI18n();
    const goalsFetched = ref(false);
    return {
      addCircle,
      t,
      goalsFetched,
      locale,
    };
  },
  data() {
    return {
      goals: [],
    };
  },
  methods: {
    async loadData(event) {
      const currentNumberOfGoals = this.goals.length;
      try {
        const response = await goalsService.getAll(currentNumberOfGoals);
        if (response.status === 200) {
          const loadedGoals = response.data;
          if (loadedGoals.length) {
            this.goals.push(...loadedGoals);
          }
        } else {
          await this.openErrorToast();
        }
      } catch (error) {
        await this.openErrorToast();
      }
      event.target.complete();
    },
    refreshData(event) {
      this.setGoals();
      event.target.complete();
    },
    async setGoals() {
      try {
        const response = await goalsService.getAll();
        if (response.status === 200) {
          this.goals = response.data;
          this.goalsFetched = true;
        } else {
          await this.openErrorToast();
        }
      } catch (error) {
        await this.openErrorToast();
      }
    },
    async openErrorToast() {
      await toastService.openErrorToast(
        this.t("toaster_error", {}, { locale: this.$store.state.appLang })
      );
    },
    openCreationGoalTitlePage() {
      this.$router.push({ name: "CreationGoalTitle" });
    },
  },
  async mounted() {
    await this.setGoals();
  },
});
</script>
